#
# spec file for package nvme-cli
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


Name:           nvme-cli
Version:        1.2
Release:        16.1
Summary:        Core nvme tools
License:        GPL-2.0
Group:          Hardware/Other
Url:            https://github.com/linux-nvme/nvme-cli
Source:         %{name}-v%{version}.tar.gz
Source2:        nvme-cli-rpmlintrc
BuildRequires:  asciidoc
BuildRequires:  libuuid-devel
BuildRequires:  xmlto
BuildRequires:  pkgconfig(libudev)
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Patch1:         0001-fabrics-add-option-to-override-drivers-queue-depth.patch
Patch2:         0002-fabrics-add-option-to-override-drivers-queue-depth-a.patch
Patch3:         0003-nvme-cli-show-more-fields-for-id-ctrl.patch
Patch4:         0004-nvme-cli-id-ctrl-display-additional-fields.patch
Patch5:         0005-nvme-cli-add-ns-descs-subcommand.patch
Patch6:         0006-fabrics-add-hostid-option-to-connect-command.patch
Patch7:         0007-nvme-cli-fix-connecting-failure-due-to-invalid-uuid-format.patch
Patch8:         0008-nvme-cli-generate-spec-compliant-uuid-nqns.patch
Patch9:         0009-fabrics-also-set-queue_size-and-nr_io_queues-on-conn.patch
Patch10:        0010-nvme-cli-Get-Feature-support-for-Extended-Host-Id.patch
Patch11:        0011-fabrics-Fix-disconnect_by_device-from-disconnecting-.patch
Patch12:        0012-nvme-cli-return-0-if-disconnect-operation-with-cfg.nqn.patch
Patch13:        0013-nvme-cli-fabrics-add-ctrl-loss-tmo-param-to-connect-cmd.patch
Patch14:        0014-nvme-cli-list-ns-fix-identifying-active-or.patch
Patch15:        0015-nvme-cli-fix-nvme-ns-desc.patch
Patch16:        0016-nvme-cli-add-NetApp-plugin.patch
Patch17:        0017-nvme-cli-add-netapp-smdevices-man-page.patch
Patch18:        0018-Documentation-add-manpage-entry-for-connect-s-ctrl-l.patch
Patch19:        0019-fabrics-add-option-to-supply-keep-alive-timeout-for.patch
Patch20:        0020-fabrics-add-ctrl-loss-tmo-to-connect-all.patch
Patch21:        0021-nvme-cli-add-fields-into-identify-controller-data-st.patch
Patch22:        0022-Increase-default-format-timeout.patch
Patch23:        0023-nvme-cli-resync-nvme.h-with-the-kernel-s.patch
Patch24:        0024-nvme-cli-replace-values-of-all-namespaces-with-NVME_.patch
Patch25:        0025-nvme-vendor-Add-get-log-LSP-LSO-fields-from-1.3-spec.patch
Patch26:        0026-nvme-cli-Implement-nvme_get_log13.patch
Patch27:        0027-nvme-cli-Remove-unnecessary-nsid-field-in-error-log.patch
Patch28:        0028-nvme-cli-add-support-of-RAE.patch
Patch29:        0029-nvme-discover-Retry-discovery-log-if-the-generation-.patch
Patch30:        0030-nvme-ioctl-retrieve-log-pages-in-4k-chunks.patch
Patch31:        0031-nvme-discover-Re-check-generation-counter-after-log-.patch
Patch32:        0032-nvme-cli-Add-rae-argument-to-nvme_get_log.patch
Patch33:        0033-nvme-cli-tests-remove-nsid-parameter-in-a-testcase-o.patch
Patch100:       0100-nvme_fc-auto-connect-scripts.patch
Patch101:       0101-Add-nvmefc-connect.target.patch
Patch102:       0102-Change-service-to-type-simple.patch

%description
NVMe is a fast, scalable, direct attached storage interface. The nvme
cli rpm installs core management tools with minimal dependencies.

%prep
%setup -q -n %{name}-v%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch100 -p1
%patch101 -p1
%patch102 -p1

%build
echo %{version} > version
make CFLAGS="%{optflags}" PREFIX=%{_prefix} %{?_smp_mflags} all

%install
make PREFIX=%{_prefix} DESTDIR=%{buildroot} install-bin install-man %{?_smp_mflags}
install -m 644 -D /dev/null %{buildroot}%{_sysconfdir}/nvme/hostnqn
install -m 644 -D completions/bash-nvme-completion.sh %{buildroot}%{_datadir}/bash_completion/completions/nvme
install -m 644 -D nvme-fc-autoconnect/70-nvmefc-autoconnect.rules %{buildroot}%{_udevrulesdir}/70-nvmefc-autoconnect.rules
install -m 644 -D nvme-fc-autoconnect/nvmefc-boot-connections.service %{buildroot}%{_unitdir}/nvmefc-boot-connections.service
install -m 644 -D nvme-fc-autoconnect/nvmefc-connect@.service %{buildroot}%{_unitdir}/nvmefc-connect@.service
install -m 644 -D nvme-fc-autoconnect/nvmefc-connect.target %{buildroot}%{_unitdir}/nvmefc-connect.target

%define services nvmefc-boot-connections.service nvmefc-connect.target

%pre
%service_add_pre %services nvmefc-connect@.service

%post
if [ ! -e %{_sysconfdir}/nvme/hostnqn ]; then
	%{_sbindir}/nvme gen-hostnqn > %{_sysconfdir}/nvme/hostnqn
fi
if [ ! -e %{_sysconfdir}/nvme/hostid ]; then
	%{_bindir}/uuidgen > %{_sysconfdir}/nvme/hostid
fi

%service_add_post %services nvmefc-connect@.service

%preun
%service_del_preun -f %services

%postun
%service_del_postun %services

%posttrans
/usr/bin/echo add 2>/dev/null >/sys/class/fc/fc_udev_device/nvme_discovery || true

%files
%defattr(-,root,root)
%doc README.md LICENSE
%{_sbindir}/nvme
%{_mandir}/man1/nvme*.1*
%dir %{_datadir}/bash_completion
%dir %{_datadir}/bash_completion/completions/
%{_datadir}/bash_completion/completions/nvme
%dir %{_sysconfdir}/nvme/
%{_udevrulesdir}/70-nvmefc-autoconnect.rules
%{_unitdir}/nvmefc-boot-connections.service
%{_unitdir}/nvmefc-connect@.service
%{_unitdir}/nvmefc-connect.target
%ghost %{_sysconfdir}/nvme/hostnqn
%ghost %{_sysconfdir}/nvme/hostid 

%changelog
* Mon Apr 15 2019 Simon Schricker <sschricker@suse.com>
- Update nvme_error_log_test to fix regression (bsc#1128538)
  + 0033-nvme-cli-tests-remove-nsid-parameter-in-a-testcase-o.patch
* Fri Apr 12 2019 Simon Schricker <sschricker@suse.com>
- Add nvmefc-connect.target to allow stopping the parameterized
  services (bsc#1127076). Also change the service type so udevd
  doesn't have to wait for the termination of the service process.
  + 0101-Add-nvmefc-connect.target.patch
  + 0102-Change-service-to-type-simple.patch
* Tue Feb 19 2019 hare@suse.de
- Rediff with upstream commit IDs:
  * 0001-fabrics-add-option-to-override-drivers-queue-depth.patch
  * 0002-fabrics-add-option-to-override-drivers-queue-depth-a.patch
  * 0003-nvme-cli-show-more-fields-for-id-ctrl.patch
  * 0004-nvme-cli-id-ctrl-display-additional-fields.patch
  * 0005-nvme-cli-add-ns-descs-subcommand.patch
  * 0006-fabrics-add-hostid-option-to-connect-command.patch
  * 0007-nvme-cli-fix-connecting-failure-due-to-invalid-uuid-format.patch
  * 0008-nvme-cli-generate-spec-compliant-uuid-nqns.patch
  * 0009-fabrics-also-set-queue_size-and-nr_io_queues-on-conn.patch
  * 0010-nvme-cli-Get-Feature-support-for-Extended-Host-Id.patch
  * 0011-fabrics-Fix-disconnect_by_device-from-disconnecting-.patch
  * 0012-nvme-cli-return-0-if-disconnect-operation-with-cfg.nqn.patch
  * 0013-nvme-cli-fabrics-add-ctrl-loss-tmo-param-to-connect-cmd.patch
  * 0014-nvme-cli-list-ns-fix-identifying-active-or.patch
  * 0015-nvme-cli-fix-nvme-ns-desc.patch
  * 0016-nvme-cli-add-NetApp-plugin.patch
  * 0017-nvme-cli-add-netapp-smdevices-man-page.patch
  * 0018-Documentation-add-manpage-entry-for-connect-s-ctrl-l.patch
  * 0019-fabrics-add-option-to-supply-keep-alive-timeout-for.patch
  * 0020-fabrics-add-ctrl-loss-tmo-to-connect-all.patch
- nvme-cli: add fields into identify controller data structure (bsc#1076004)
  + 0021-nvme-cli-add-fields-into-identify-controller-data-st.patch
- Increase default format timeout (bsc#1076004)
  + 0022-Increase-default-format-timeout.patch
- nvme-cli: resync nvme.h with the kernel's (bsc#1076004)
  + 0023-nvme-cli-resync-nvme.h-with-the-kernel-s.patch
- nvme-cli: replace values of all namespaces with NVME_NSID_ALL (bsc#1076004)
  + 0024-nvme-cli-replace-values-of-all-namespaces-with-NVME_.patch
- nvme/vendor: Add get log LSP/LSO fields from 1.3 spec (bsc#1076004)
  + 0025-nvme-vendor-Add-get-log-LSP-LSO-fields-from-1.3-spec.patch
- nvme-cli: Implement nvme_get_log13 (bsc#1076004)
  + 0026-nvme-cli-Implement-nvme_get_log13.patch
- nvme-cli: Remove unnecessary nsid field in error-log (bsc#1076004)
  + 0027-nvme-cli-Remove-unnecessary-nsid-field-in-error-log.patch
- nvme-cli: add support of RAE (bsc#1076004)
  + 0028-nvme-cli-add-support-of-RAE.patch
- nvme-discover: Retry discovery log if the generation counter changes (bsc#1076004)
  + 0029-nvme-discover-Retry-discovery-log-if-the-generation-.patch
- nvme-ioctl: retrieve log pages in 4k chunks (bsc#1076004)
  + 0030-nvme-ioctl-retrieve-log-pages-in-4k-chunks.patch
- nvme-discover: Re-check generation counter after log page transfer (bsc#1076004)
  + 0031-nvme-discover-Re-check-generation-counter-after-log-.patch
- nvme-cli: Add 'rae' argument to nvme_get_log() (bsc#1076004)
  + 0032-nvme-cli-Add-rae-argument-to-nvme_get_log.patch
- nvme_fc auto-connect scripts (bsc#1044189)
  + 0100-nvme_fc-auto-connect-scripts.patch
- Remove patch:
  - add-missing-nvme_id_crtl-fileds.patch
* Tue May 29 2018 jthumshirn@suse.com
- Add ctrl-loss-tmo option to connect-all command (bsc#1084379)
  + 0020-fabrics-add-ctrl-loss-tmo-to-connect-all.patch
* Wed May  2 2018 jthumshirn@suse.com
- Add keep-alive-tmo option to connect-all command (bsc#1090568)
  + 0019-fabrics-add-option-to-supply-keep-alive-timeout-for.patch
* Tue Apr 10 2018 jthumshirn@suse.com
- Add Documentatiosn for connect's -l switch (bsc#1088706)
  + 0018-Documentation-add-manpage-entry-for-connect-s-ctrl-l.patch
* Tue Apr 10 2018 jthumshirn@suse.com
- Fix building of NetApp vendor plugin (bsc#1080672)
* Tue Feb 13 2018 jthumshirn@suse.com
- Add NetApp vendor plugin (bsc#1080672)
  + 0001-nvme-cli-add-NetApp-plugin.patch
  + 0002-nvme-cli-add-netapp-smdevices-man-page.patch
* Fri Feb  9 2018 jthumshirn@suse.com
- Fix "nvme ns-desc" command (bsc#1076127)
  + 0015-nvme-cli-fix-nvme-ns-desc.patch
* Fri Feb  9 2018 jthumshirn@suse.com
- fix identifying active or allocated namespaces list (bsc#1076113)
  + 0014-nvme-cli-list-ns-fix-identifying-active-or.patch
* Tue Jan 30 2018 jthumshirn@suse.com
- Add ability to specify controller loss timeout when connecting (bsc#1078032)
  + 0013-nvme-cli-fabrics-add-ctrl-loss-tmo-param-to-connect-cmd.patch
* Thu Jan 18 2018 jthumshirn@suse.com
- Return 0 if disconnect command is successful (bsc#1076417)
  + 0012-nvme-cli-return-0-if-disconnect-operation-with-cfg.nqn.patch
* Tue Jan  9 2018 jthumshirn@suse.com
- Discard '/dev/' prefix when disconnecting (bsc#1058538)
  + 0011-fabrics-Fix-disconnect_by_device-from-disconnecting-.patch
* Tue Nov 21 2017 jthumshirn@suse.com
-  Decode KATO feature in nvme get-feature (bsc#1065430)
  + 0010-nvme-cli-Get-Feature-support-for-Extended-Host-Id.patch
* Tue Oct 17 2017 jthumshirn@suse.com
- allow override queue depth and nr io queues on connect-all (bsc#1063462)
  + 0009-fabrics-also-set-queue_size-and-nr_io_queues-on-conn.patch
* Thu Sep  7 2017 jthumshirn@suse.com
- Generate Spec compliant UUID NQNs (bsc#1057498)
  + 0008-nvme-cli-generate-spec-compliant-uuid-nqns.patch
* Thu Aug 31 2017 jthumshirn@suse.com
- Fix hostid parsing (bsc#1049272)
  + 0007-nvme-cli-fix-connecting-failure-due-to-invalid-uuid-format.patch
* Fri Jun 30 2017 jthumshirn@suse.com
- Add hostid option to connect command (bsc#1045293)
  + 0006-fabrics-add-hostid-option-to-connect-command.patch
* Mon Jun 26 2017 jthumshirn@suse.com
- Create nvme files and directories in /etc/nvme (bsc#1045931 )
* Mon Jun 26 2017 jthumshirn@suse.com
- Provide nvme ns-descs subcommand (bsc#1038235)
  + 0005-nvme-cli-add-ns-descs-subcommand.patch
* Fri Jun 16 2017 jthumshirn@suse.com
-  Also re-build documentation on each build (bsc#1037297)
* Wed Jun 14 2017 jthumshirn@suse.com
- Add NVMe over Fabrics specific id-ctrl fields (bsc#1037293)
  + add-missing-nvme_id_crtl-fileds.patch
  + 0003-nvme-cli-show-more-fields-for-id-ctrl.patch
  + 0004-nvme-cli-id-ctrl-display-additional-fields.patch
* Fri May 12 2017 jthumshirn@suse.com
- Add possibility to change queue depth at connect time (bsc#1037297)
  + 0001-fabrics-add-option-to-override-drivers-queue-depth.patch
  + 0002-fabrics-add-option-to-override-drivers-queue-depth-a.patch
* Mon Apr 24 2017 jthumshirn@suse.com
- Update to version v1.2 (FATE#322735 ,bsc#1033410):
  * Include endian.h for byte/host order functions
  * nvme-cli: Add nvme hostnqn generation option
  * nvme.spec/debian: Auto generate host nqn as part of install
  * Documentation: Add entry for gen-hostnqn
  * Regenerate Documentation
  * Fix read/write man pages
  * get-features: Don't try to read the data buffer for sel == 3
  * Documentation: fix location of device reset
  * Regen documentation
  * Remove debian/ directory
  * Remove pyc files generated by 'make test'
  * Moving the bash completion files to the standard
  * lightnvm: default to -1 on lun begin and end
  * nvme-cli: fabrics: Fix to pass "host_traddr" to the kernel driver.
  * nvme-cli: id-ctrl: Fix memory leak for JSON.
  * nvme-cli: id-ns: Fix memory leak for JSON.
  * nvme-cli: error-log: Fix memory leak for JSON.
  * nvme-cli: resv-report: Fix memory leak.
  * nvme-cli: smart-log: Fix memory leak for JSON.
  * nvme-cli: fw-log: Fix memory leak for JSON.
  * nvme-cli: json_add_smart_log(): Fix memory leak for JSON.
  * nvme-cli: smart-log: Allow negative values for temp sensors.
  * Don't print unimplemented sensor
  * Build without uuid
  * get-ns-id: Exit when no device provided.
  * nvme-cli: id-ctrl: Add vendor fields in JSON id-ctrl.
  * nvme-cli: nvme.c: Allow plug-ins to access to output formats and helper.
  * nvme-cli: Western Digital/HGST plug-in.
  * nvme-cli: Western Digital/HGST plug-in documentation.
  * <linux/nvme.h>: Correct NVMF enum values to match NVMe-oF rev 1.0
  * fabrics: Handle space-padded TRSVCID and TRADDR fields
  * nvme-cli: bug-fix: use right file name for perror.
  * move show_intel_smart_log to intel-nvme.c
  * remove json_add_smart_log
  * remove nvme_intel_smart_log
  * move struct nvme_additional_smart_log to intel-nvme.c
  * nvme-cli/format: use existing LBAF if none requested
  * nvme-cli: Release v1.2
* Thu Mar  2 2017 jthumshirn@suse.com
-  Update to upstream release v1.1 (FATE#322735)
  * This fixes multiple compiler warnings for 32-bit and other environments
    from v1.0, adds more documentation to fabrics, removes the libudev
    dependency entirely from this project, adds a framework for unit testing
    devices, and fixes usage for user defined install paths
* Thu Sep 15 2016 jthumshirn@suse.com
- Update to upstream release v0.9
  - Remove merged remove-version-from-list.patch
  * New extensions, fabrics support, a bug fixes. The 'list' command
    is liberated from its udev dependency, and no longer requires
    CONFIG_IO_STRICT_DEVMEM be disabled.
* Wed Aug 31 2016 jthumshirn@suse.com
- Don't map controller registers in 'list' command (boo#986891)
  + remove-version-from-list.patch
* Tue Aug  9 2016 jthumshirn@suse.com
- Update to upstream release v0.8
  - Remove merged patch 0001-bash-completion-Remove-shebang-line.patch
  * Code re-organized to support new extensions. While these are called
    "plugins", they currently have to be built into the executable. Support
    for dynamically loadable plugins is under consideration.
  * LightNVM is added as a built-in plugin.
  * Intel vendor specific commands and structure decodings are supported
    in a new intel plugin.
  * Support for NVMe-over-Fabrics
  * New output format "json" for a subset of commands that decode returned
    structures.
  * Lots of various documentation and minor code fixes.
* Wed Jun  1 2016 jthumshirn@suse.com
- Update to upstream release v0.7
  + 0001-bash-completion-Remove-shebang-line.patch
  Keith writes:
    Just a few minor updates and documentation fixes. There is also a new
    option for passthrough commands that can be used to help detect data
    over/under run.
    Tagging a stable release so we can consider features that bring in other
    transports and third party extensions.
* Wed Apr 13 2016 jthumshirn@suse.com
- Exclude build on s390x (FATE#319560)
* Fri Mar 18 2016 jthumshirn@suse.com
- Update to upstream release v0.5
    The v0.4 breakage should all be resolved now. Tagging release
    v0.5, and back to stability.
* Wed Mar  2 2016 jthumshirn@suse.com
- Update to upstream release v0.4
* Mon Feb 15 2016 jthumshirn@suse.com
- Fix display of version number (boo#966740)
* Thu Feb 11 2016 jthumshirn@suse.com
- Initial packaging for openSUSE
